(defrule isPrinterOn "staat de printer aan?"
         (declare (salience 1))
         (not (intermFact (name printerOn) (value yes)))
         ?cannotPrint <- (intermFact (name cannotPrint) (value yes))
         (not (problem solved))
         =>
         (ask "Is your printer switched on?")
)

(defrule turnPrinterOn "kan je je printer aanzetten"
         (declare (salience 1))
         (not (intermFact (name printerOn) (value yes)))
         ?printerOn <- (intermFact (name printerOn) (value no))
         (not (problem solved))
         =>
         (ask "Does your printer turn on when you press the power button?")
)

(defrule cableOke "is kabel ok"
         (declare (salience 2))
         (not (intermFact (name cableOk)))
         ?printerOn <- (intermFact (name printerOn) (value no))
         ?turnOn <- (intermFact (name turnedOn) (value no))
         (not (problem solved)) 
         =>
         (ask "Is the cable that supplies the printer with electricity ok?")
)

(defrule printerWasUit "printer was uit"
         (declare (salience 2))
         ?printerOn <- (intermFact (name printerOn) (value no))
         ?turnOn <- (intermFact (name turnedOn) (value yes))
         (not (problem solved)) 
         =>
         (printout t "Your printer was not turned on, please try to print again." crlf)
         (assert (problem solved))
)

(defrule powerFailure "oplossing power failure"
         (declare (salience 3))
         ?printerOn <- (intermFact (name printerOn) (value no))
         ?turnOn <- (intermFact (name turnedOn) (value no))
         ?cableOk <- (intermFact (name cableOk) (value yes))
         (not (problem solved)) 
         =>
         (printout t "There is probably a power failure. Please check with maintenance." crlf)
         (assert (problem solved))
)

(defrule plugCable "oplossing kabel in stopcontact"
         (declare (salience 3))
         ?printerOn <- (intermFact (name printerOn) (value no))
         ?turnOn <- (intermFact (name turnedOn) (value no))
         ?cableOk <- (intermFact (name cableOk) (value no))
         (not (problem solved)) 
         =>
         (printout t "Plug the powercord in the electicity mains, and try to turn on the printer again." crlf)
         (assert (problem solved))
)

(defrule paperInTray "is er papier in de invoerlade"
         (declare (salience 1))
         (not (intermFact (name paperAv)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         (not (problem solved)) 
         =>
         (ask "Is the paper tray filled with paper?" )
)

(defrule paperRefill "Vul papier bij"
         (declare (salience 2))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value no))
         (not (problem solved))
         =>
         (printout t "Please refill the paper tray, and try to print again." crlf)
         (assert (problem solved))
)

(defrule paperOut "komt er papier uit de printer"
         (declare (salience 2))
         (not (intermFact (name paperOut)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value yes))
         (not (problem solved)) 
         =>
         (ask "Does any paper come out of the printer?" )
)

(defrule isPaperJam "is paperjam?"
         (declare (salience 3))
         (not (intermFact (name paperJam)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value no))
         (not (problem solved)) 
         =>
         (ask "Is there a piece of paper stuck in the printer?" )
)

(defrule paperJam "papier zit vast, probeer los te maken"
         (declare (salience 4))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value no))
         ?paperJam  <- (intermFact (name paperJam)  (value yes))
         (not (problem solved)) 
         =>
         (printout t "Please try to remove the paper gently, otherwise contact maintenance." crlf)
         (assert (problem solved))
)

(defrule isNetwork "is het een networkprinter"
         (declare (salience 3))
         (not (intermFact (name isNetwork)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value no))
         (not (problem solved))
         =>
         (ask "Is the printer a network printer?" )
)

(defrule isConnected "is printer goed verbonden"
         (declare (salience 4))
         (not (intermFact (name isConnected)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value no))
         ?network   <- (intermFact (name isNetwork) (value no))
         (not (problem solved)) 
         =>
         (ask "Is the printer connected to the computer?")
)

(defrule connect "verbind printer->computer"
         (declare (salience 5))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value no))
         ?network   <- (intermFact (name isNetwork) (value no))
         ?connected <- (intermFact (name isConnected) (value no))
         (not (problem solved)) 
         =>
         (printout t "Connect the printer to the computer, and try to print again." crlf)
         (assert (problem solved))
)

(defrule hasDrivers "heb je de nieuwste drivers"
         (declare (salience 6))
         (not (intermFact (name hasDrivers)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         (or (and ?paperAv   <- (intermFact (name paperAv)   (value yes))
                  ?paperOut  <- (intermFact (name paperOut)  (value no))
                  (or ?doDrivers <- (intermFact (name isConnected) (value yes))
                      ?doDrivers <- (intermFact (name isTimeout) (value no))
                  )
             )
             (and ?blank  <- (intermFact (name blank) (value no))
                  ?seated <- (intermFact (name seated) (value yes))
             )
         )
         (not (problem solved)) 
         =>
         (ask "Do you have the latest drivers installed for your printer?" )
)

(defrule downloadDrivers "download laatste drivers"
         (declare (salience 1))
         ?drivers   <- (intermFact (name hasDrivers) (value no))
         (not (problem solved))
         =>
         (printout t "Download the latest drivers from the website of the manufacturer of you printer, and try to print again." crlf)
         (assert (problem solved))
)

(defrule contactManufac "neem contact op met fabrikant"
         (declare (salience 1))
         ?drivers   <- (intermFact (name hasDrivers) (value yes))
         (not (problem solved)) 
         =>
         (printout t "Contact the manufacturer of your printer." crlf)
         (assert (problem solved))
)

(defrule timeOut "geeft printer timeout"
         (declare (salience 5))
         (not (intermFact (name isTimeout)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value no))
         ?network   <- (intermFact (name isNetwork) (value yes))
         (not (problem solved)) 
         =>
         (ask "Does the computer give a timeout?" )
)

(defrule contactAdmin "contact admin"
         (declare (salience 6))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperAv   <- (intermFact (name paperAv)   (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value no))
         ?network   <- (intermFact (name isNetwork) (value yes))
         ?timeout   <- (intermFact (name isTimeout) (value yes))
         (not (problem solved)) 
         =>
         (printout t "Please get in touch with your System Administrator about this problem." crlf)
         (assert (problem solved))
)

(defrule paperOutput "staat er iets op papier"
         (declare (salience 2))
         (not (intermFact (name blank)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value yes))
         (not (problem solved)) 
         =>
         (ask "Does the printer leave the paper blank?")
)

(defrule cartridgeInstallled "zitten er cartridges in"
         (declare (salience 3))
         (not (intermFact (name cartridge)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value yes))
         ?blank     <- (intermFact (name blank)  (value yes))
         (not (problem solved)) 
         =>
         (ask "Are there cartridges installed in the printer?")
)

(defrule replaceCartridges "vervang de cartridges"
         (declare (salience 4))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value yes))
         ?blank     <- (intermFact (name blank)     (value yes))
         ?cartridge <- (intermFact (name cartridge) (value yes))
         (not (problem solved)) 
         =>
         (printout t "Your cartridges are probably empty. Try to replace them." crlf)
         (assert (problem solved))
)

(defrule installCartridges "doe er cartridges in"
         (declare (salience 4))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value yes))
         ?blank     <- (intermFact (name blank)     (value yes))
         ?cartridge <- (intermFact (name cartridge) (value no))
         (not (problem solved)) 
         =>
         (printout t "You should install the appropriate cartridges." crlf)
         (assert (problem solved))
)

(defrule checkSeating "kijk of de cartridges er goed in zitten"
         (declare (salience 3))
         (not (intermFact (name seated)))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value yes))
         ?blank     <- (intermFact (name blank)     (value no))
         (not (problem solved)) 
         =>
         (ask "Are the cartridges properly seated in the printer?")
)

(defrule reinstallCartridges "de cartridges zaten niet goed"
         (declare (salience 4))
         ?printerOn <- (intermFact (name printerOn) (value yes))
         ?paperOut  <- (intermFact (name paperOut)  (value yes))
         ?blank     <- (intermFact (name blank)     (value yes))
         ?seated    <- (intermFact (name seated)    (value no))
         (not (problem solved))
         =>
         (ask "You should take the cartridges out and install them properly.")
)

; rules

; 0. !printing  :: TurnedOn?
; 1. !printing, !printerOn :: NotTurnedOn "Kan je em aan zetten"
; 2. !printing, !printerOn, !turnOn :: NoPowerCable "is cabel oke"
; 3. !printing, !printerOn, !turnOn, kabelOke :: "powerfailure, einde"
; 4. !printing, !printerOn, !turnOn, !kabelOke :: "Doe in stopcontact, einde"
; 5.  !printing, !printerOn, turnOn, :: "je printer stond uit, retry, einde"
; 6.  !printing, printerOn  :: "papier niet op"
; 7. !printing, printerOn, !paper :: "Stop papier in, einde"
;8.  !printing, printerOn, !papierOut, papier :: "Paperjam?"
;9.  !printing, printerOn, !papierOut, papier, paperjam :: "trek papier er voorzichtig uit, einde"
;10. !printing, printerOn, !papierOut, papier, !paperjam :: "is netwerk printer?"
;11. !printing, printerOn, !papierOut, papier, !paperjam, !netwerkprinter:: "Is de printer connected to computer?"
;12. !printing, printerOn, !papierOut, papier, !paperjam, !netwerkprinter, !connected:: "sluit em aan in usb oid, einde"
;13. !printing, printerOn, !papierOut, papier, !paperjam, !netwerkprinter, connected:: "Laatste driver installed?"
;14. !printing, printerOn, !papierOut, papier, !paperjam, !netwerkprinter, connected, !Drivers:: "Haal drivers op?, einde"
;15. !printing, printerOn, !papierOut, papier, !paperjam, !netwerkprinter, connected, Drivers:: "contact your fabrikant, einde? "
;16. !printing, printerOn, !papierOut, papier, !paperjam, netwerkprinter :: "Geeft computer een timeout?"
;17. !printing, printerOn, !papierOut, papier, !paperjam, netwerkprinter, timeout :: "Roep anton, einde"
;18. !printing, printerOn, !papierOut, papier, !paperjam, netwerkprinter, !timeout :: "-> Drivers"
;19. !printing, printerOn, papierOut :: "Staat er iet op het papier?"
;20. !printing, printerOn, papierOut, blank:: "zitten de catriges er in?"
;21. !printing, printerOn, papierOut, blank, catrige:: "vervangen"
;22. !printing, printerOn, papierOut, blank, !catrige:: "doe ze er in..."
;23. !printing, printerOn, papierOut, !blank :: "inktpatronen goed vast?"
;24. !printing, printerOn, papierOut, !blank, seated :: -> driver
;25. !printing, printerOn, papierOut, !blank, !seated :: "vast maken, einde"

; Vragen
;   1. printerOn
;   2. turnedOn
;   3. CableOke
;   4. paper
;   5. paperOutput
;   6. paperJam
;   7. networkPrinter
;   8. connected
;   9. timeout
;  10. blank
;  11. cartridge
;  12. seated
;  13. drivers

;Oplossingen

;# Your printer was turned off.
;# There is a power outage. Warn your concierge
;# Plug the powercord in the electicity mains.
;# Refill the paper tray
;# Gently remove the paper from the printer.
;# Connect the USB or paralel cable to the computer
;# Ask your system administrator to fix your netwerk connection
;# Replace your cartridges. It's almost empty.
;# You need a cartridge to print. Buy one and install it.
;# Firmly pres down the cartridge in the socket.
;# You need the latest drivers. Download them from the website of your printer vendor.
;# Your printer is broken. Contact your printer vendor.


