(deftemplate wordAndPos "sla het woord en zijn positie op"
             (slot word
                   (type SYMBOL)
             )
             (slot pos
                   (type INTEGER)
             )
)

(deftemplate lexAndPos "sla het gelexte woord en zijn positie op"
             (slot word
                   (type SYMBOL)
             )
             (slot pos
                   (type INTEGER)
             )
)

; deze regels parsen alle woorden naar de bijbehorende begrippen en slaan hun positie op.
; dit doen we om te zorgen dat we de zin vertalen naar basisbegrippen, die we vervolgens kunnen 
; gebruiken om tussenfeiten vast te stellen

(defrule lexYes
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word yes) (pos ?pos))
             ?i <- (wordAndPos (word positive) (pos ?pos))
             ?i <- (wordAndPos (word correct) (pos ?pos))
             ?i <- (wordAndPos (word sure) (pos ?pos))
             ?i <- (wordAndPos (word agreed) (pos ?pos))
             ?i <- (wordAndPos (word ok) (pos ?pos))
             ?i <- (wordAndPos (word okay) (pos ?pos))
             ?i <- (wordAndPos (word y) (pos ?pos))
             ?i <- (wordAndPos (word can) (pos ?pos))
             ?i <- (wordAndPos (word yeah) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word yes) (pos ?pos)))
)

(defrule lexNo
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word not) (pos ?pos))
             ?i <- (wordAndPos (word negative) (pos ?pos))
             ?i <- (wordAndPos (word cant) (pos ?pos))
             ?i <- (wordAndPos (word cannot) (pos ?pos))
             ?i <- (wordAndPos (word dont) (pos ?pos))
             ?i <- (wordAndPos (word can't) (pos ?pos))
             ?i <- (wordAndPos (word don't) (pos ?pos))
             ?i <- (wordAndPos (word incorrect) (pos ?pos))
             ?i <- (wordAndPos (word n) (pos ?pos))
             ?i <- (wordAndPos (word no) (pos ?pos))
             ?i <- (wordAndPos (word nothing) (pos ?pos))
         )
         => 
         (retract ?i)
         (assert (lexAndPos (word no) (pos ?pos)))
)

(defrule lexOff
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word off) (pos ?pos))
             ?i <- (wordAndPos (word offline) (pos ?pos))
         )
         => 
         (retract ?i)
         (assert (lexAndPos (word off) (pos ?pos)))
)

(defrule lexOn
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word on) (pos ?pos))
             ?i <- (wordAndPos (word online) (pos ?pos))
         )
         => 
         (retract ?i)
         (assert (lexAndPos (word on) (pos ?pos)))
)

(defrule lexPrinting
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word printing) (pos ?pos))
             ?i <- (wordAndPos (word print) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word printing) (pos ?pos)))
)

(defrule lexPrinter
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word printer) (pos ?pos))
             ?i <- (wordAndPos (word inkjet) (pos ?pos))
             ?i <- (wordAndPos (word laserjet) (pos ?pos))
             ?i <- (wordAndPos (word deskjet) (pos ?pos))
             ?i <- (wordAndPos (word laserprinter) (pos ?pos))
             ?i <- (wordAndPos (word copier) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word printer) (pos ?pos)))
)

(defrule lexBroken
         (declare (salience 1000))
         (or (wordAndPos (word broken) (pos ?pos))
             (wordAndPos (word battered) (pos ?pos))
         )
         =>
         (assert (lexAndPos (word broken) (pos ?pos)))
)


(defrule lexPaper
         (declare (salience 1000))
         (or (wordAndPos (word paper) (pos ?pos))
             (wordAndPos (word sheet) (pos ?pos))
             (wordAndPos (word envelope) (pos ?pos))
             (wordAndPos (word page)     (pos ?pos))
             (wordAndPos (word pages)    (pos ?pos))
         )
         =>
         (assert (lexAndPos (word paper) (pos ?pos)))
)


(defrule lexBlank
         (declare (salience 1000))
         (or (wordAndPos (word blank) (pos ?pos))
             (wordAndPos (word empty) (pos ?pos))
             (wordAndPos (word white) (pos ?pos))
         )
         =>
         (assert (lexAndPos (word blank) (pos ?pos)))
)

(defrule lexTurnOn
         (declare (salience 1001))
         (or (wordAndPos (word turn) (pos ?pos))
             (wordAndPos (word switch) (pos ?pos))
         )
         ?on <- (wordAndPos (word on) (pos ?pos2))
         (test (< ?pos ?pos2))
         =>
         (retract ?on)
         (assert (lexAndPos (word turnOn) (pos ?pos)))
)

(defrule lexEmpty
         (declare (salience 1000))
         (or (wordAndPos (word empty) (pos ?pos))
             (wordAndPos (word depleted) (pos ?pos))
         )
         =>
         (assert (lexAndPos (word empty) (pos ?pos)))
)

(defrule lexCartridge
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word cartridge) (pos ?pos))
             ?i <- (wordAndPos (word toner) (pos ?pos))
         )
         => 
         (retract ?i)
         (assert (lexAndPos (word cartridge) (pos ?pos)))
)

(defrule lexCable
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word usb) (pos ?pos))
             ?i <- (wordAndPos (word cable) (pos ?pos))
             ?i <- (wordAndPos (word cord) (pos ?pos))
             ?i <- (wordAndPos (word connection) (pos ?pos))
             ?i <- (wordAndPos (word connector) (pos ?pos))
         )
         => 
         (retract ?i)
         (assert (lexAndPos (word cable) (pos ?pos)))
)

(defrule lexConnection
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word link) (pos ?pos))
             ?i <- (wordAndPos (word connection) (pos ?pos))
         )
         => 
         (retract ?i)
         (assert (lexAndPos (word connection) (pos ?pos)))
)

(defrule lexVague
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word vague) (pos ?pos))
             ?i <- (wordAndPos (word unclear) (pos ?pos))
             ?i <- (wordAndPos (word fuzzy) (pos ?pos))
             ?i <- (wordAndPos (word blurred) (pos ?pos))
         )
         => 
         (retract ?i)
         (assert (lexAndPos (word vague) (pos ?pos)))
)

(defrule lexQuality
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word quality) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word quality) (pos ?pos)))
)

(defrule lexStuck
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word stuck) (pos ?pos))
             ?i <- (wordAndPos (word jammed) (pos ?pos))
         )
         => 
         (retract ?i)
         (assert (lexAndPos (word stuck) (pos ?pos)))
)

(defrule lexTimeout
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word timeout) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word timeout) (pos ?pos)))
)

(defrule lexOutput
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word output) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word output) (pos ?pos)))
)

(defrule lexNetwork
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word network) (pos ?pos))
             ?i <- (wordAndPos (word intranet) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word output) (pos ?pos)))
)

(defrule lexSeated
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word seated) (pos ?pos))
             ?i <- (wordAndPos (word fitted) (pos ?pos))
             ?i <- (wordAndPos (word placed) (pos ?pos))
             ?i <- (wordAndPos (word positioned) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word output) (pos ?pos)))
)

(defrule lexDrivers
         (declare (salience 1000))
         (or ?i <- (wordAndPos (word drivers) (pos ?pos))
             ?i <- (wordAndPos (word program) (pos ?pos))
             ?i <- (wordAndPos (word software) (pos ?pos))
         )
         =>
         (retract ?i)
         (assert (lexAndPos (word output) (pos ?pos)))
)

;   1. printerOn
;   2. turnedOn
;   3. CableOke
;   4. paper
;   5. paperOutput
;   6. paperJam
;   7. networkPrinter
;   8. connected
;   9. timeout
;  10. blank
;  11. cartridge
;  12. seated
;  13. drivers

; 
; (deffacts alternateWords
;           ;(alterns (name yes)      (alters yes positive correct sure agreed ok okay y))
;           ;(alterns (name no)       (alters no negative incorrect n))
;           ;(alterns (name unknown)  (alters unknown))
;           (alterns (name negative) (alters negative not))
;           (alterns (name off)      (alters off offline))
;           (alterns (name unable)   (alters unable cannot cant))
; 
; 
;           (alterns (name broken)   (alters broken battered))
;           (alterns (name paper)    (alters paper sheet envelope))
;           (alterns (name blank)    (alters blank empty white))
;           (alterns (name empty)    (alters empty depleted))
;
;           ;(alterns (name printer)  (alters printer inkjet laserjet deskjet laserprinter copier))
;           ;(alterns (name printing) (alters printing print working))
;           (alterns (name cartridge)(alters ink cartridge toner))
;           (alterns (name cable)    (alters usb cable cord connection connector))
;           (alterns (name connection) (alters link connection))
;           (alterns (name vague)      (alters vague unclear fuzzy blurred))
;           (alterns (name quality)    (alters quality))
;           (alterns (name stuck)      (alters stuck jammed))
;           (alterns (name timeout) (alters timeout))
; )
